package com.its.api.its.service.database;

import com.its.api.its.global.CodeManager;
import com.its.api.its.model.dto.code.TbCmmnCdDto;
import com.its.api.its.model.dto.database.TbLeglHldyInfrDto;
import com.its.api.its.model.entity.database.TbLeglHldyInfr;
import com.its.api.its.repository.database.TbLeglHldyInfrRepository;
import com.its.api.its.service.code.TbCmmnCdService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

/**
 * 휴일관리 서비스
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class TbLeglHldyInfrService {

    private final TbLeglHldyInfrRepository repo;
    private final TbCmmnCdService cmmnCdService;

    // 데이터 1건 조회, 없으면 exception
    private TbLeglHldyInfr requireOne(String id) {
        return repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbLeglHldyInfrDto> findAll() {
        List<TbLeglHldyInfrDto> result = new ArrayList<>();
        List<TbLeglHldyInfr> data = this.repo.findAll();
        for (TbLeglHldyInfr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbLeglHldyInfrDto findById(String id) {
        TbLeglHldyInfr entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbLeglHldyInfrDto updateById(String id, TbLeglHldyInfrDto.TbLeglHldyInfrUpdReq req) {
        TbLeglHldyInfr entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbLeglHldyInfrDto> mergeInfoList(List<TbLeglHldyInfrDto.TbLeglHldyInfrUpdReq> reqList) {
        List<TbLeglHldyInfrDto> result = new ArrayList<>();
        for (TbLeglHldyInfrDto.TbLeglHldyInfrUpdReq req : reqList) {
            TbLeglHldyInfr obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbLeglHldyInfrDto mergeInfo(String ymd, TbLeglHldyInfrDto.TbLeglHldyInfrUpdReq req) {
        TbLeglHldyInfr obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbLeglHldyInfrDto deleteById(String id) {
        TbLeglHldyInfr entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbLeglHldyInfrDto> deleteByIds(List<String> ids) {
        List<TbLeglHldyInfrDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbLeglHldyInfr> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    // 휴일 유형 코드 목록 조회
    @Transactional(readOnly = true)
    public List<TbLeglHldyInfrDto.LeglHldyType> findAllByLeglHldyType() {
        List<TbLeglHldyInfrDto.LeglHldyType> result = new ArrayList<>();
        List<TbCmmnCdDto> data = this.cmmnCdService.findAllByCmmnClsfCd(CodeManager.HLDY_DAY_CD);
        if (data != null) {
	        data.forEach(obj -> {
	            if (("Y").equals(obj.getUseYn())) {
	                result.add(new TbLeglHldyInfrDto.LeglHldyType(obj));
	            }
	        });
	    }
        return result;
    }
}
